# frozen_string_literal: true

RSpec.describe 'block builder with a name as a passed object' do
  # Можно сделать заглушку и не создавать миграции и т.д. https://github.com/rails/rails/blob/855cb4bef21f3f658b8cd192cfd087bcbe70006a/actionview/test/template/form_helper/form_with_test.rb#L261-L268

  # Не имеет значение что передается в `simple_form_for` первым параметром или через `as`, все преобразовывается в symbol
  # Поэтому тесты можно объединить в один файл? Для active record и active model сделать только по несколько основных а остальные для symbol?

  # Логика для form_for
  # https://github.com/rails/rails/blob/eca6c273fe2729b9634907562c2717cf86443b6b/actionview/lib/action_view/helpers/form_helper.rb#L430-L443

  #########################
  # Покрыть тестами:
  #########################
  # -------------------
  # @bem         = options.delete(:bem)
  # @bem_cascade = options.delete(:bem_cascade)
  # @css_classes = [options.delete(:class), options.delete(:cls)]
  # @js          = options.delete(:js)
  # @mixins      = MixinList.new(options.delete(:mix))
  # @modifiers   = ModifierList.new(block, element, options.delete(:mods))
  # @tag         = build_tag(options.delete(:tag))
  # @html_attrs  = options
  # -------------------
  # bem: false,nil... bem_cascade: false.. cls: [], class: ..
  # { bem: bem, js: js, mods: mods, mix: mix, bem_cascade: bem_cascade, cls: css_classes }
  # -------------------
  # Bemer.config
  # Bemer::SimpleForm.config
  # -------------------
  # simple_form_for([:admin, Article.new])
  # simple_form_for('')
  # -------------------
  # @bem                      = false
  # @default_block_tag        = :div
  # @default_element_tag      = :div
  # @element_name_separator   = '__'
  # @modifier_name_separator  = '_'
  # @modifier_value_separator = '_'
  # -------------------
  # @bemify_namespaces                   = %i[error hint input wrapper label]
  # @input_type_modifiers_for_namespaces = %i[input wrapper label]

  context 'when an object name is used as a block name' do
    context 'when the object name as a string' do
      it 'creates an HTML form as a block' do
        form = simple_form_for('') do |f|
          f.input :elem
        end

        p form
        expect(form).to have_tag(:form) do
          without_tag 'form[class]'
          without_tag 'input[name="elem"][class]'
        end
      end
    end

    # it 'creates an HTML form as a block with elements' do
    #   form = simple_form_for '' do |f|
    #     f.input :elem
    #   end

    #   p form
    #   expect(form).to have_tag(:form, with: { class: 'form' }) do
    #     with_tag :input, with: { class: 'form__elem' }
    #   end
    # end
  end

  # context 'when a block name is specified using the `as` parameter' do
  #   it 'creates an HTML form as a block' do
  #     form = simple_form_for(:form, as: :form_block)

  #     expect(form).to have_tag(:form, with: { class: 'form' })
  #   end
  # end

  # context 'when a block name is specified using the `block` parameter' do
  #   it 'creates an HTML form as a block' do
  #     form = simple_form_for(:form, block: :form_block)

  #     expect(form).to have_tag(:form, with: { class: 'form-block' })
  #   end

  #   it 'creates an HTML form as a block with elements' do
  #     form = simple_form_for :form, block: :form_block do |f|
  #       f.input :elem
  #     end

  #     expect(form).to have_tag(:form, with: { class: 'form' }) do
  #       with_tag :input, with: { class: 'form__elem' }
  #     end
  #   end
  # end

  # =================

  # , as: :form, block: :search

  # context 'when an object name is overridden with `as`' do
  # context 'when an object name as a symbol' do
  # end

  # when an object name is used as a block name
  # when a block name is specified using the `as` parameter
  # when a block name is specified using the `block` parameter

  # context 'when the block name is overridden with `as`' do
  # end

  # context 'when the block name is overridden with `block`' do
  # end

  # it 'creates an HTML form as a block with element' do
  #   form = simple_form_for :form do |f|
  #     f.input :elem
  #     f.simple_fields_for :hhh do |b|
  #       b.input :ddd
  #     end
  #   end

  #   expect(form).to have_tag(:form, with: { class: 'form' }) do
  #     with_tag :input, with: { class: 'form__elem' }
  #   end
  # end
end
